void set_clock( int freq ) {

  char old_crtc_ext_disp;
  int M, N, P, R;
  float Q;
  int postDiv;
  int mhz100 = freq / 10;
  kgiu8 tmp1, tmp2;
  /*int ext_div = 0;*/
  int clkCntl;

  if (clock_data.clockchiptype != CLKCHIP_MACH64CT) {
    printk( ("mach64ct: Sorry, can only handle Mach64CT so far\n"));
  }

 old_crtc_ext_disp = inb(ioCRTC_GEN_CNTL+3);
  outb(ioCRTC_GEN_CNTL+3, old_crtc_ext_disp | (CRTC_EXT_DISP_EN >> 24));

  M = info.RefDivider;
  R = info.RefFreq;

  /* Read out which clock for textmode is in use. Usually it is clock #1, */
  /* but you never know what strange configurations exist...              */
  clkCntl = (inb(VGA_MISC_R) >> 2) & 3;
  PDEBUG(("mach64ct: Programming clock #%d\n",clkCntl));
  
  if (mhz100 < info.MinFreq) mhz100 = info.MinFreq;
  if (mhz100 > clock_data.maxclock/10) mhz100 = clock_data.maxclock/10;

  Q = (mhz100 * M)/(2.0 * R);

  /* Not supported yet */
  /*if ((mach64ChipType == MACH64_VT || mach64ChipType == MACH64_GT) &&
    (mach64ChipRev & 0x01)) */
  if (Q > 255) {
    PWARNING(("mach64ct: Warning: Q > 255\n"));
    Q = 255;
    P = 0;
  }
  else if (Q > 127.5) {
    P = 0;
  }
  else if (Q > 63.75) {
    P = 1;
  }
  else if (Q > 31.875) {
    P = 2;
  }
  else if (Q >= 16) {
    P = 3;
  }
  else {
    PWARNING(("mach64ct: Warning: Q < 16\n"));
    P = 3;
  }
  postDiv = 1 << P;

  N = (int)(Q * postDiv + 0.5);

  PDEBUG(("mach64ct: Q = %f N = %d P = %d, postDiv = %d R = %d M = %d\n",
          Q, N, P, postDiv, R, M));
  PDEBUG(("mach64ct: New freq: %.2f\n", 
          (double)((2 * R * N)/(M * postDiv)) / 100.0));

  outb(ioCLOCK_CNTL + 1, PLL_VCLK_CNTL << 2);
  tmp1 = inb(ioCLOCK_CNTL + 2);
  outb(ioCLOCK_CNTL + 1, (PLL_VCLK_CNTL  << 2) | PLL_WR_EN);
  outb(ioCLOCK_CNTL + 2, tmp1 | 0x04);
  outb(ioCLOCK_CNTL + 1, VCLK_POST_DIV << 2);
  tmp2 = inb(ioCLOCK_CNTL + 2);
  outb(ioCLOCK_CNTL + 1, ((VCLK0_FB_DIV + clkCntl) << 2) | PLL_WR_EN);
  outb(ioCLOCK_CNTL + 2, N);
  outb(ioCLOCK_CNTL + 1, (VCLK_POST_DIV << 2) | PLL_WR_EN);
  outb(ioCLOCK_CNTL + 2,
       (tmp2 & ~(0x03 << (2 * clkCntl))) | (P << (2 * clkCntl)));
  outb(ioCLOCK_CNTL + 1, (PLL_VCLK_CNTL << 2) | PLL_WR_EN);
  outb(ioCLOCK_CNTL + 2, tmp1 & ~0x04);

  /* Not supported yet */
  /*if ((mach64ChipType == MACH64_VT || mach64ChipType == MACH64_GT) &&
      (mach64ChipRev & 0x01))*/

  usleep(5000);

  (void)inb(ioDAC_REGS); /* Clear DAC Counter */
  outb(ioCRTC_GEN_CNTL+3, old_crtc_ext_disp);
}

